# PSF-LoginServer - master - net.psforever.objects.avatar.PlayerControl
PSF - LoginServer - master - net.psforever.objects.avatar.PlayerControl
Keywords: PSF LoginServer master net.psforever.objects.avatar.PlayerControl

PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package avatar
  Definition Classes
    objects
- Avatar
- Avatars
- BattleRank
- Certification
- CommandRank
- CorpseControl
- Cosmetic
- DeployableToolbox
- FirstTimeEvents
- Implant
- LoadoutManager
- PlayerControl
- SpecialCarry

c

net.psforever.objects.avatar

# PlayerControl 

###
Companion object PlayerControl

#### class PlayerControl extends Actor with JammableBehavior with Damageable with ContainableBehavior with AggravatedBehavior with AuraEffectBehavior with RespondsToZoneEnvironment

Source
  PlayerControl.scala

Linear Supertypes
RespondsToZoneEnvironment, AuraEffectBehavior, AggravatedBehavior, ContainableBehavior, Damageable, JammableBehavior, Actor, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. PlayerControl
2. RespondsToZoneEnvironment
3. AuraEffectBehavior
4. AggravatedBehavior
5. ContainableBehavior
6. Damageable
7. JammableBehavior
8. Actor
9. AnyRef
10. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new PlayerControl(player: Player, avatarActor: ActorRef[Command])

### Type Members

1.  type Receive = PartialFunction[Any, Unit]
   Definition Classes
     Actor

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def AggravatedObject: Player
   Definition Classes
     PlayerControl → AggravatedBehavior
5.  def AggravatedReaction: Boolean
   Definition Classes
     AggravatedBehavior
6.  def AggravationCleanup(id: Long): Unit
   Definition Classes
     AggravatedBehavior
7.  def ApplicableEffect(effect: Aura): Unit

   Only pre-apporved aura effects will be emitted by this target.

   Only pre-apporved aura effects will be emitted by this target.

   effect

     the aura effect

   Definition Classes
     AuraEffectBehavior
8.  def AuraTargetObject: Player
   Definition Classes
     PlayerControl → AuraEffectBehavior
9.  def CancelJammeredSound(target: Any): Unit

   Stop the jammered buzzing.

   Stop the jammered buzzing.

   target

     an object that can be affected by the jammered status

   Definition Classes
     PlayerControl → JammableBehavior
   See also

     `JammableBehavior.CancelJammeredSound`

10.  def CancelJammeredStatus(target: Any): Unit

    Deactivate the effects of the jammered status.

    Deactivate the effects of the jammered status. Due to considerations of the object that is the target, this is left to be implemented by a subclass. We merely stop the timer.

    target

      an object that can be affected by the jammered status

    Definition Classes
      PlayerControl → JammableBehavior
11.  def CleanupAggravationTimer(id: Long): Unit
    Definition Classes
      AggravatedBehavior
12.  def ContainerObject: Player
    Definition Classes
      PlayerControl → ContainableBehavior
13.  def DamageAwareness(target: Player, cause: DamageResult, damageToHealth: Int, damageToArmor: Int, damageToStamina: Int, damageToCapacitor: Int): Unit
14.  def DamageableObject: Player

    Contextual access to the object being the target of this damage.

    Contextual access to the object being the target of this damage. Needs declaration in lowest implementing code.

    returns

      the entity controlled by this actor

    Definition Classes
      PlayerControl → Damageable
15.  def DestructionAwareness(target: Player, cause: DamageResult): Unit

    The player has lost all his vitality and must be killed.
    Shift directly into a state of being dead on the client by setting health to zero points, whereupon the player will perform a dramatic death animation.

    The player has lost all his vitality and must be killed.
    Shift directly into a state of being dead on the client by setting health to zero points, whereupon the player will perform a dramatic death animation. Stamina is also set to zero points. If the player was in a vehicle at the time of demise, special conditions apply and the model must be manipulated so it behaves correctly. Do not move or completely destroy the `Player` object as its coordinates of death will be important.
    A maximum revive waiting timer is started. When this timer reaches zero, the avatar will attempt to spawn back on its faction-specific sanctuary continent.

    target

      na

    cause

      na

16.  def EndAllAggravation(): Unit
    Definition Classes
      AggravatedBehavior
17.  def EndAllEffects(): Unit

    Stop the target entity from emitting all aura particle effects.

    Stop the target entity from emitting all aura particle effects.

    Definition Classes
      AuraEffectBehavior
18.  def EndAllEffectsAndUpdate(): Unit

    Stop the target entity from emitting all aura particle effects.

    Stop the target entity from emitting all aura particle effects. Animate the new particle effect state.

    Definition Classes
      AuraEffectBehavior
19.  def EndAuraEffect(effect: Aura): Boolean

    Stop the target entity from emitting the aura particle effect, if it currently is.

    Stop the target entity from emitting the aura particle effect, if it currently is.

    effect

      the target effect

    returns

      `true`, if the effect was being emitted but has been stopped `false`, if the effect was not approved or is not being emitted

    Definition Classes
      AuraEffectBehavior
20.  def EndAuraEffectAndUpdate(effect: Aura): Unit

    Stop the target entity from emitting the aura particle effect, if it currently is.

    Stop the target entity from emitting the aura particle effect, if it currently is. If the effect has been stopped, animate the new particle effect state.

    Definition Classes
      AuraEffectBehavior
21.  def HandleDamage(target: Player, cause: DamageResult, damageToHealth: Int, damageToArmor: Int, damageToStamina: Int, damageToCapacitor: Int): Unit

    na

    na

    target

      na

22.  def InteractWith: Option[PieceOfEnvironment]
    Definition Classes
      RespondsToZoneEnvironment
23.  def InteractiveObject: Player
    Definition Classes
      PlayerControl → RespondsToZoneEnvironment
24.  def JammableObject: Player

    `ZoneAware` is used for callback to the event systems

    `ZoneAware` is used for callback to the event systems

    Definition Classes
      PlayerControl → JammableBehavior
25.  def MessageDeferredCallback(msg: Any): Unit

    Reaction to the initial deferrence of a message that should handle the visual aspects of not immediately addressing the message.

    Reaction to the initial deferrence of a message that should handle the visual aspects of not immediately addressing the message. To be implemented.

    msg

      the deferred message

    Definition Classes
      PlayerControl → ContainableBehavior
26.  def PerformDamage(target: Target, applyDamageTo: Output): Unit

    Assess the vital statistics of the target, apply the damage, and determine if any of those statistics changed.

    Assess the vital statistics of the target, apply the damage, and determine if any of those statistics changed. By default, only take an interest in the change of "health". If implementing custom damage with no new message handling, override this method.

    target

      the entity to be damaged

    applyDamageTo

      the function that applies the damage to the target in a target-tailored fashion

    Attributes
      protected
    Definition Classes
      PlayerControl → Damageable
    See also

      `ResolutionCalculations.Output`

27.  def PutItemInSlotCallback(item: Equipment, slot: Int): Unit

    Reaction to an item being placed into a container.

    Reaction to an item being placed into a container. To be implemented.

    item

      the item that was removed

    slot

      the slot from which is was removed

    Definition Classes
      PlayerControl → ContainableBehavior
28.  def RemoveAggravatedEntry(id: Long): Aura
    Definition Classes
      AggravatedBehavior
29.  def RemoveItemFromSlotCallback(item: Equipment, slot: Int): Unit

    Reaction to an item being removed a container.

    Reaction to an item being removed a container. To be implemented.

    item

      the item that was removed

    slot

      the slot from which is was removed

    Definition Classes
      PlayerControl → ContainableBehavior
30.  def RepairToolValue(item: Tool): Float
31.  def RepeatMessageLater(msg: Any): Unit

    Defer a message until later.

    Defer a message until later.

    msg

      the message to defer

    Definition Classes
      ContainableBehavior
    See also

      `ContainableBehavior.Defer`

      `DeferrableMsg`

32.  def Reset(): Unit

    Stop blocking messages.

    Stop blocking messages.

    Definition Classes
      ContainableBehavior
33.  def Resume(): Unit

    Decrement the flag for blocking messages.

    Decrement the flag for blocking messages.

    Definition Classes
      ContainableBehavior
34.  def SetInteraction(attribute: EnvironmentTrait, action: Interaction): Unit
    Definition Classes
      RespondsToZoneEnvironment
35.  def SetInteractionStop(attribute: EnvironmentTrait, action: Interaction): Unit
    Definition Classes
      RespondsToZoneEnvironment
36.  def StartAuraEffect(effect: Aura, duration: Long): Unit

    An aura particle effect is to be emitted by the target.

    An aura particle effect is to be emitted by the target. If the effect was not previously applied to the target in an ongoing manner, animate it appropriately.

    effect

      the effect to be emitted

    duration

      for how long the effect will be emitted

    returns

      the active effect index number

    Definition Classes
      AuraEffectBehavior
37.  def StartJammeredSound(target: Any, dur: Int): Unit

    Start the jammered buzzing.

    Start the jammered buzzing. Although, as a rule, the jammering sound effect should last as long as the jammering status, Infantry seem to hear the sound for a bit longer than the effect.

    target

      an object that can be affected by the jammered status

    dur

      the duration of the timer, in milliseconds; by default, 30000

    Definition Classes
      PlayerControl → JammableBehavior
    See also

      `JammableBehavior.StartJammeredSound`

38.  def StartJammeredStatus(target: Any, dur: Int): Unit

    Perform a variety of tasks to indicate being jammered.

    Perform a variety of tasks to indicate being jammered. Deactivate implants (should also uninitialize them), delay stamina regeneration for a certain number of turns, and set the jammered status on specific holstered equipment.

    target

      an object that can be affected by the jammered status

    dur

      the duration of the timer, in milliseconds

    Definition Classes
      PlayerControl → JammableBehavior
    See also

      `JammableBehavior.StartJammeredStatus`

39.  def SwapItemCallback(item: Equipment, fromSlot: Int): Unit

    Reaction to the existence of a swap item being produced from a container into the environment.

    Reaction to the existence of a swap item being produced from a container into the environment. To be implemented.

    item

      the item that was removed

    fromSlot

      the slot from where the item was removed (where it previous was)

    Definition Classes
      PlayerControl → ContainableBehavior
40.  def TestForEffect(effect: Aura): Boolean

    Is the target entity emitting the aura effect?

    Is the target entity emitting the aura effect?

    effect

      the effect being tested

    returns

      `true`, if the effect is currently being emitted; `false`, otherwise

    Definition Classes
      AuraEffectBehavior
41.  def TryAggravationEffectActivate(data: DamageResult): Option[AggravatedDamage]
    Definition Classes
      AggravatedBehavior
42.  def TryJammerEffectActivate(target: Any, cause: DamageResult): Unit

    If the target can be validated against, affect it with the jammered status.

    If the target can be validated against, affect it with the jammered status.

    target

      the objects to be determined if affected by the source's jammering

    cause

      the source of the "jammered" status

    Definition Classes
      JammableBehavior
43.  def UpdateAuraEffect(target: Target): Unit

    An override callback to display aura effects emitted.

    An override callback to display aura effects emitted.

    target

      the entity from which the aura effects are being emitted

    Definition Classes
      PlayerControl → AuraEffectBehavior
44.  def Wait(): Unit

    Increment the flag for blocking messages.

    Increment the flag for blocking messages.

    Definition Classes
      ContainableBehavior
45.  val aggravatedBehavior: Receive
    Definition Classes
      AggravatedBehavior
46.  def aroundPostRestart(reason: Throwable): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
47.  def aroundPostStop(): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
48.  def aroundPreRestart(reason: Throwable, message: Option[Any]): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
49.  def aroundPreStart(): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
50.  def aroundReceive(receive: akka.actor.Actor.Receive, msg: Any): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
51.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
52.  val auraBehavior: Receive
    Definition Classes
      AuraEffectBehavior
53.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
54.  final val containerBehavior: Receive
    Definition Classes
      ContainableBehavior
55.  implicit val context: ActorContext
    Definition Classes
      Actor
56.  var deployablePair: Option[(Deployable, ConstructionItem)]

    assistance for deployable construction, retention of the construction item

57.  def doEnvironmentInteracting(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit
    Definition Classes
      RespondsToZoneEnvironment
58.  def doInteractingWithDeath(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit

    Death causes players to die outright.

    Death causes players to die outright. It's not even considered as environmental damage anymore.

    obj

      the target

    body

      the environment

    data

      additional interaction information, if applicable

59.  def doInteractingWithGantryField(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit
60.  def doInteractingWithLava(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit

    Lava causes players to take (considerable) damage until they inevitably die.

    Lava causes players to take (considerable) damage until they inevitably die.

    obj

      the target

    body

      the environment

    data

      additional interaction information, if applicable

61.  def doInteractingWithWater(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit

    Water causes players to slowly suffocate.

    Water causes players to slowly suffocate. When they (finally) drown, they will die.

    obj

      the target

    body

      the environment

    data

      additional interaction information, if applicable; for players, this will be data from any mounted vehicles

62.  val environmentBehavior: Receive
    Definition Classes
      RespondsToZoneEnvironment
63.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
64.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
65.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
66.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
67.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
68.  val interactWith: Option[PieceOfEnvironment]

    the environment that we are currently in interaction with

    the environment that we are currently in interaction with

    Definition Classes
      RespondsToZoneEnvironment
69.  val interactionTime: Long

    how long the current interaction has been progressing in the current way

    how long the current interaction has been progressing in the current way

    Definition Classes
      RespondsToZoneEnvironment
70.  val interactionTimer: Cancellable

    a gesture of automation added to the interaction

    a gesture of automation added to the interaction

    Definition Classes
      RespondsToZoneEnvironment
71.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
72.  val jammableBehavior: Receive
    Definition Classes
      JammableBehavior
73.  val jammedSound: Boolean

    flag for jammed sound

    flag for jammed sound

    Attributes
      protected
    Definition Classes
      JammableBehavior
74.  val jammeredSoundTimer: Cancellable

    the sound timer

    the sound timer

    Attributes
      protected
    Definition Classes
      JammableBehavior
75.  val jammeredStatusTimer: Cancellable

    the effect timer

    the effect timer

    Attributes
      protected
    Definition Classes
      JammableBehavior
76.  val lockerControlAgent: ActorRef

    control agency for the player's locker container (dedicated inventory slot #5)

77.  def loseDeployableOwnership(obj: Deployable): Boolean
78.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
79.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
80.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
81.  final val originalTakesDamage: akka.actor.Actor.Receive

    a duplicate of the core implementation for the default mixin hook, for use in overriding

    a duplicate of the core implementation for the default mixin hook, for use in overriding

    Definition Classes
      Damageable
82.  def postRestart(reason: Throwable): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
83.  def postStop(): Unit
    Definition Classes
      PlayerControl → Actor
84.  def preRestart(reason: Throwable, message: Option[Any]): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
85.  def preStart(): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
86.  def receive: Receive
    Definition Classes
      PlayerControl → Actor
87.  def recoverFromEnvironmentInteracting(): Unit

    Reset the environment encounter fields and completely stop whatever is the current mechanic.

    Reset the environment encounter fields and completely stop whatever is the current mechanic. This does not perform messaging relay either with mounted occupants or with any other service.

    Definition Classes
      PlayerControl → RespondsToZoneEnvironment
88.  implicit final val self: ActorRef
    Definition Classes
      Actor
89.  final def sender(): ActorRef
    Definition Classes
      Actor
90.  def setExoSuit(exosuit: types.ExoSuitType.Value, subtype: Int): Boolean
91.  def setupDeployable(obj: Deployable, tool: ConstructionItem): Unit
92.  def stopEnvironmentInteracting(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit
    Definition Classes
      RespondsToZoneEnvironment
93.  def stopInteractingWithWater(obj: PlanetSideServerObject, body: PieceOfEnvironment, data: Option[OxygenStateTarget]): Unit

    When out of water, the player is no longer suffocating.

    When out of water, the player is no longer suffocating. The player does have to endure a recovery period to get back to normal, though.

    obj

      the target

    body

      the environment

    data

      additional interaction information, if applicable; for players, this will be data from any mounted vehicles

94.  var submergedCondition: Option[OxygenState]

    suffocating, or regaining breath?

95.  def suicide(): Unit
96.  def supervisorStrategy: SupervisorStrategy
    Definition Classes
      Actor
97.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
98.  val takesDamage: akka.actor.Actor.Receive

    the official mixin hook; `orElse` onto the "control" `Actor` `receive`; or, cite the `originalTakesDamage` protocol during inheritance overrides

    the official mixin hook; `orElse` onto the "control" `Actor` `receive`; or, cite the `originalTakesDamage` protocol during inheritance overrides

    Definition Classes
      Damageable
99.  def toString(): String
    Definition Classes
      AnyRef → Any
100.  def unhandled(message: Any): Unit
     Definition Classes
       Actor
101.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
102.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
103.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException]) @native()

### Inherited from RespondsToZoneEnvironment

### Inherited from AuraEffectBehavior

### Inherited from AggravatedBehavior

### Inherited from ContainableBehavior

### Inherited from Damageable

### Inherited from JammableBehavior

### Inherited from Actor

### Inherited from AnyRef

### Inherited from Any

### Ungrouped